package com.engine.organization.mapper.scheme;


import com.engine.organization.entity.TreeData;
import com.engine.organization.entity.scheme.po.SchemePO;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * @Author dxfeng
 * @description:
 * @Date 2022/5/9
 * @Version V1.0
 **/
public interface SchemeMapper {


    /**
     * 根据No查询登记方案
     *
     * @param schemeNo
     * @return
     */
    List<SchemePO> listByNo(@Param("schemeNo") String schemeNo);

    /**
     * 根据No查询登记方案
     *
     * @param schemeNo
     * @return
     */
    SchemePO getSchemeByNo(@Param("schemeNo") String schemeNo);


    /**
     * 查询所有被引用的ID
     *
     * @return
     */
    List<String> listUsedId();
    /**
     * 根据ID查询登记方案
     *
     * @param id
     * @return
     */
    SchemePO getSchemeByID(@Param("id") long id);

    /**
     * 根据ID查询登记方案列表
     *
     * @param ids
     * @return
     */
    @MapKey("id")
    List<Map<String, Object>> listSchemesByIds(@Param("ids") Collection<Long> ids);

    /**
     * 新增，忽略null字段
     *
     * @param schemePO
     * @return
     */
    int insertIgnoreNull(SchemePO schemePO);

    /**
     * 修改，修改所有字段
     *
     * @param schemePO
     * @return
     */
    int updateScheme(SchemePO schemePO);

    /**
     * 更新禁用标记
     *
     * @param schemePO
     * @return
     */
    int updateForbiddenTagById(SchemePO schemePO);

    /**
     * 批量删除登记方案
     *
     * @param ids
     */
    int deleteByIds(@Param("ids") Collection<Long> ids);

    /**
     * 获取左侧树
     * @return
     */
    ArrayList<TreeData> getTreeData();

    List<SchemePO> getSchemesByIds(@Param("ids")Collection<Long> ids);
}
